<?php

	/**************************************************

		Project	sBLOG <http://sblog.sourceforge.net>
		Author	Servous <servous@gmail.com>
		License	GPL

	 **************************************************/

	// make sure that config.php has been uploaded
	if(!file_exists('config.php') && file_exists('install/index.php')) {
		header('Location: install/index.php');
		exit;
	}
	else if(!file_exists('config.php') && !file_exists('install/index.php')) {
		echo 'config.php is corrupt or missing!';
		exit;
	}

	if(isset($_GET['date']) && strlen(intval($_GET['date'])) >= 6) {
		$year		= substr($_GET['date'], 0, 4);
		$month	= substr($_GET['date'], 4, 2);
		$day		= substr($_GET['date'], 6, 2);
		$date		= intval($_GET['date']);
	}
	else {
		$date = 0;
	}
	
	if(isset($_GET['cat']) && intval($_GET['cat']) > 0) {
		$cat = intval($_GET['cat']);
	}
	else {
		$cat = null;
	}
	
	// include headers
	require('inc/tpl_header.php');			// header
	require('inc/tpl_menu.php');				// menu
	
	// include blocks
	require('inc/block_custom.php');			// custom blocks

	// include functions
	require('inc/sRenderPost.php');

	// declare truncate() is not already declared
	if(!function_exists('truncate')) {
		require('inc/func_truncate.php');
	}

	/* start <sblog_main> */
	ob_start();
	
?>
<!-- START OF LIST -->
<?php

	require('inc/mysql.php');

	// fetch all posts from a certain category
	if(isset($cat) && $cat != 0) {
		$query = 'SELECT d.id, UNIX_TIMESTAMP(d.date_created) AS date_created, UNIX_TIMESTAMP(d.date_modified) AS date_modified, d.topic, d.text, d.category_id, c.category FROM ' . $conf_mysql_prefix . 'data AS d, ' . $conf_mysql_prefix . 'categories AS c WHERE d.draft=\'0\' AND d.category_id=c.id AND category_id=\'' . $cat . '\' ORDER BY date_created DESC, date_modified DESC';
	}
	// fetch posts for yyyymmdd
	else if(isset($date) && strlen($date) == 8) {
		$query = 'SELECT d.id, UNIX_TIMESTAMP(d.date_created) AS date_created, UNIX_TIMESTAMP(d.date_modified) AS date_modified, d.topic, d.text, d.category_id, c.category FROM ' . $conf_mysql_prefix . 'data AS d, ' . $conf_mysql_prefix . 'categories AS c WHERE d.draft=\'0\' AND d.category_id=c.id AND SUBSTRING(d.date_created, 1, 10)=\'' . $year . '-' . $month . '-' . $day . '\' ORDER BY date_created DESC, date_modified DESC';
	}
	// fetch posts for yyyymm
	else if(isset($date) && strlen($date) == 6) {
		$query = 'SELECT d.id, UNIX_TIMESTAMP(d.date_created) AS date_created, UNIX_TIMESTAMP(d.date_modified) AS date_modified, d.topic, d.text, d.category_id, c.category FROM ' . $conf_mysql_prefix . 'data AS d, ' . $conf_mysql_prefix . 'categories AS c WHERE d.draft=\'0\' AND d.category_id=c.id AND SUBSTRING(d.date_created, 1, 7)=\'' . $year . '-' . $month . '\' ORDER BY date_created DESC, date_modified DESC';
	}
	// fetch all posts
	else {
		$query = 'SELECT d.id, UNIX_TIMESTAMP(d.date_created) AS date_created, UNIX_TIMESTAMP(d.date_modified) AS date_modified, d.topic, d.text, d.category_id, c.category FROM ' . $conf_mysql_prefix . 'data AS d, ' . $conf_mysql_prefix . 'categories AS c WHERE d.draft=\'0\' AND d.category_id=c.id ORDER BY date_created DESC, date_modified DESC';
	}

	$q = mysql_query($query);
	$n = mysql_num_rows($q);

	if($n > 0) {
		$counter = 0;
		
		// set active page
		$page = (array_key_exists('p', $_GET) && intval($_GET['p']) > 0) ? intval($_GET['p']) : 1;

		// prevent division by zero error
		if(isset($conf_page_disp) && $conf_page_disp > 0) {
			$pages = ceil($n / $conf_page_disp);
		}
		else {
			$conf_page_disp = 5;
			$pages = 0;
		}
	
		// jump to active page in database
		@mysql_data_seek($q, (($page - 1) * $conf_page_disp));

		while($r = mysql_fetch_assoc($q)) {
			$counter++;
			if($counter > $conf_page_disp) {
				break;
			}

			// render the post
			sRenderPost($r['id'], $r['category_id'], $r['category'], $r['date_created'], $r['date_modified'], $r['topic'], $r['text']);

		}

		if($pages > 1) {
			echo "\t\t\t" . '<!-- START OF PAGES -->' . "\n";
			echo "\t\t\t" . '<div class="sblog_pages">' . "\n";
			echo "\t\t\t\t" . '<div class="sblog_pages_prev">' . "\n";
			
			if($page > 1) {
				echo "\t\t\t\t\t" . '<a href="' . $_SERVER['PHP_SELF'] . '?cat=' . $cat . '&amp;date=' . $date . '&amp;p=1" title="' . lang('First') . '">&laquo; ' . lang('First') . '</a> <a href="' . $_SERVER['PHP_SELF'] . '?cat=' . $cat . '&amp;date=' . $date . '&amp;p=' . ($page - 1) . '" title="' . lang('Previous') . '">&laquo; ' . lang('Previous') . '</a>' . "\n";
			}
			else {
				echo "\t\t\t\t\t" . '&laquo; ' . lang('First') . ' &laquo; ' . lang('Previous') . "\n";
			}
			
			echo "\t\t\t\t" . '</div>' . "\n";
			echo "\t\t\t\t" . '<div class="sblog_pages_next">' . "\n";
			
			if($page < $pages) {
				echo "\t\t\t\t\t" . '<a href="' . $_SERVER['PHP_SELF'] . '?cat=' . $cat . '&amp;date=' . $date . '&amp;p=' . ($page + 1) . '" title="' . lang('Next') . '">' . lang('Next') . ' &raquo;</a> <a href="' . $_SERVER['PHP_SELF'] . '?cat=' . $cat . '&amp;date=' . $date . '&amp;p=' . $pages . '" title="' . lang('Last') . '">' . lang('Last') . ' &raquo;</a>' . "\n";
			}
			else {
				echo "\t\t\t\t\t" . lang('Next') . ' &raquo; ' . lang('Last') . ' &raquo;' . "\n";
			}
			
			echo "\t\t\t\t" . '</div>' . "\n";
			echo "\t\t\t\t" . '<div class="sblog_pages_current">' . "\n";
			echo "\t\t\t\t\t" . $page . ' ' . lang('of') . ' ' . $pages . "\n";
			echo "\t\t\t\t" . '</div>' . "\n";
			echo "\t\t\t" . '</div>' . "\n";
			echo "\t\t\t" . '<!-- END OF PAGES -->' . "\n";
		}
	}
	else {
		if(array_key_exists('cat', $_GET)) {
			echo '<div class="sblog_quote">' . lang('There are no posts assigned to this category.') . '</div>' . "\n";
		}
		else if(array_key_exists('date', $_GET)) {
			echo '<div class="sblog_quote">' . lang('No posts were posted on this date.') . '</div>' . "\n";
		}
		else {
			echo '<div class="sblog_quote">' . lang('The sBLOG is empty!') . '</div>' . "\n";
		}
	}
	
	mysql_close();

?>
			<!-- END OF LIST -->
<?php

	$tpl_temp = trim(ob_get_contents());
	$tpl_main = str_replace('<sblog_main>', $tpl_temp, $tpl_main);
	
	ob_end_clean();
	
	/* end <sblog_main> */
	
	require('inc/tpl_foot.php');

	echo $tpl_main;

?>